Attribute VB_Name = "MainModule"
' ************************************************
' Aligner main program.
'
' This add-in aligns the selected controls in
' rows, columns, or both.
' ************************************************

Option Explicit

Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

' Style.
Global Const ALIGN_ROW = 0
Global Const ALIGN_COL = 1
Global Const ALIGN_ROW_AND_COL = 2
' Row options.
Global Const ALIGN_TOP = 0
Global Const ALIGN_MIDDLE = 1
Global Const ALIGN_BOTTOM = 2
' Column options.
Global Const ALIGN_LEFT = 0
Global Const ALIGN_CENTER = 1
Global Const ALIGN_RIGHT = 2

' ************************************************
' The Aligner Main subroutine.
' ************************************************
Sub Main()
Dim section As String
Dim val As String * 256
Dim length As Long
    
    ' Check the correct section of VB.INI.
    section = "Add-Ins32"
    
    ' See if Aligner.AlignHandler is in VB.INI.
    length = GetPrivateProfileString(section, _
        "Aligner.AlignHandler", "", val, _
        256, "VBADDIN.INI")
    
    ' If not, add it.
    If length = 0 Then _
        WritePrivateProfileString section, _
            "Aligner.AlignHandler", "0", _
            "VBADDIN.INI"
End Sub
