VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ScrollerHandler"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' This class actually creates scrolling areas.
' ************************************************
Option Explicit

' The environment instance.
Public VBInstance As VBIDE.Application

' ************************************************
' Create the scrolling area.
' ************************************************
Public Sub AfterClick()
Const MARGIN = 60
Dim min_x As Single
Dim max_x As Single
Dim min_y As Single
Dim max_y As Single
Dim x As Single
Dim y As Single
Dim ctl As Object
Dim controls As VBIDE.SelectedControlTemplates
Dim frm As Object
Dim scroll_area As Object
Dim viewport As Object
Dim hscroll As Object
Dim vscroll As Object
Dim package As Object
Dim scroll_area_name As String
Dim viewport_name As String
Dim hscroll_name As String
Dim vscroll_name As String
Dim package_name As String
Dim scroll_area_wid As Single
Dim scroll_area_hgt As Single
Dim viewport_wid As Single
Dim viewport_hgt As Single
Dim package_wid As Single
Dim package_hgt As Single
Dim filename As String
Dim fp As Integer

    If NoControls() Then Exit Sub
    
    Set frm = VBInstance.ActiveProject.ActiveForm
    Set controls = frm.SelectedControlTemplates
    
    ' Find the largest and smallest coordinates.
    Set ctl = controls.Item(0)
    min_x = ctl.Properties("Left")
    max_x = min_x
    min_y = ctl.Properties("Top")
    max_y = min_y
    
    For Each ctl In controls
        On Error Resume Next
        x = ctl.Properties("Left")
        If Err.Number = 0 Then
            If min_x > x Then min_x = x
            If max_x < x Then max_x = x
            y = ctl.Properties("Top")
            If min_y > y Then min_y = y
            If max_y < y Then max_y = y
        End If
        x = x + ctl.Properties("Width")
        If Err.Number = 0 Then
            If min_x > x Then min_x = x
            If max_x < x Then max_x = x
            y = y + ctl.Properties("Height")
            If min_y > y Then min_y = y
            If max_y < y Then max_y = y
        End If
        On Error GoTo 0
    Next ctl
   
    ' Create the scrolling area.
    Set scroll_area = frm.ControlTemplates.Add("PictureBox")
    With scroll_area.Properties
        .Item("Left") = 0
        .Item("Top") = 0
        scroll_area_wid = max_x - min_x + 2 * MARGIN
        scroll_area_hgt = max_y - min_y + 2 * MARGIN
        .Item("Width") = scroll_area_wid
        .Item("Height") = scroll_area_hgt
        .Item("BorderStyle") = vbTransparent
    End With
    
    ' Move the items into the scrolling area.
    For Each ctl In controls
        Set ctl.Container = scroll_area
        With ctl.Properties
            .Item("Left") = .Item("Left") - min_x + MARGIN
            .Item("Top") = .Item("Top") - min_y + MARGIN
        End With
    Next ctl
    
    ' Create the scrolling area controls.
    Set viewport = frm.ControlTemplates.Add("PictureBox")
    Set hscroll = frm.ControlTemplates.Add("HScrollBar")
    Set vscroll = frm.ControlTemplates.Add("VScrollBar")
    Set package = frm.ControlTemplates.Add("PictureBox")
    
    Set viewport.Container = package
    Set hscroll.Container = package
    Set vscroll.Container = package
    Set scroll_area.Container = viewport
    
    With viewport.Properties
        .Item("Left") = 0
        .Item("Top") = 0
        viewport_wid = .Item("Width") - _
            .Item("ScaleWidth") + scroll_area_wid
        viewport_hgt = .Item("Height") - _
            .Item("ScaleHeight") + scroll_area_hgt
        .Item("Width") = viewport_wid
        .Item("Height") = viewport_hgt
        .Item("BorderStyle") = vbBSSolid
    End With
    With hscroll.Properties
        .Item("Left") = 0
        .Item("Top") = viewport_hgt
        .Item("Width") = viewport_wid
    End With
    With vscroll.Properties
        .Item("Left") = viewport_wid
        .Item("Top") = 0
        .Item("Height") = viewport_hgt
    End With
    With package.Properties
        .Item("Left") = min_x
        .Item("Top") = min_y
        package_wid = viewport_wid + _
            vscroll.Properties.Item("Width")
        package_hgt = viewport_hgt + _
            hscroll.Properties.Item("Height")
        .Item("Width") = package_wid
        .Item("Height") = package_hgt
        .Item("BorderStyle") = vbTransparent
    End With
    
    ' Create a file containing code for the
    ' scrolling area.
    scroll_area_name = scroll_area.Properties.Item("Name")
    viewport_name = viewport.Properties.Item("Name")
    hscroll_name = hscroll.Properties.Item("Name")
    vscroll_name = vscroll.Properties.Item("Name")
    package_name = package.Properties.Item("Name")
    
    fp = FreeFile
    filename = App.Path & "\Scroller.TMP"
    Open filename For Output As fp
    Print #fp, "Private Sub " & package_name & "_Resize()"
    Print #fp, "    ' Call ArrangeScrollingArea to"
    Print #fp, "    ' set scroll bar parameters."
    Print #fp, "    ArrangeScrollingArea _"
    Print #fp, "        " & package_name & ", _"
    Print #fp, "        " & viewport_name & ", _"
    Print #fp, "        " & hscroll_name & ", _"
    Print #fp, "        " & vscroll_name & ", _"
    Print #fp, "        " & scroll_area_name
    Print #fp, "End Sub"
    Print #fp, "Private Sub " & hscroll_name & "_Change()"
    Print #fp, "    ' Move the scrolling area."
    Print #fp, "    " & scroll_area_name & _
        ".Left = -" & hscroll_name & ".Value"
    Print #fp, "End Sub"
    Print #fp, "Private Sub " & hscroll_name & "_Scroll()"
    Print #fp, "    ' Move the scrolling area."
    Print #fp, "    " & scroll_area_name & _
        ".Left = -" & hscroll_name & ".Value"
    Print #fp, "End Sub"
    Print #fp, "Private Sub " & vscroll_name & "_Change()"
    Print #fp, "    ' Move the scrolling area."
    Print #fp, "    " & scroll_area_name & _
        ".Top = -" & vscroll_name & ".Value"
    Print #fp, "End Sub"
    Print #fp, "Private Sub " & vscroll_name & "_Scroll()"
    Print #fp, "    ' Move the scrolling area."
    Print #fp, "    " & scroll_area_name & _
        ".Top = -" & vscroll_name & ".Value"
    Print #fp, "End Sub"
    Close fp
    
    ' Insert the file into the Form's code.
    frm.InsertFile filename
    
    ' Delete the file.
    Kill filename

    ' Give the user a reminder popup.
    MsgBox "Remember to:" & vbCrLf & vbCrLf & _
        "1. Add file Scroller.BAS to your project." & vbCrLf & _
        "2. Invoke " & package_name & _
        "_Resize in this form's Load event handler." & vbCrLf & _
        "3. (Optional) Add code to resize " & _
        package_name & " when the form resizes.", _
        vbOKOnly + vbInformation, "Reminder"
End Sub

' ************************************************
' Return true if there are no controls selected.
' ************************************************
Function NoControls() As Boolean
    NoControls = True
    
    ' Sneak up on the collection of selected
    ' controls so we don't try to access an
    ' object that is Nothing.
    If VBInstance.ActiveProject Is Nothing Then _
        Exit Function
    If VBInstance.ActiveProject.ActiveForm _
        Is Nothing Then _
        Exit Function
    If VBInstance.ActiveProject.ActiveForm. _
        SelectedControlTemplates.Count < 1 Then _
        Exit Function
            
    NoControls = False
End Function

