VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Scroller"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Attribute VB_Description = "Scroller"
' ************************************************
' This class implements the Scroller add-in.
'
' If includes the ConnectAddIn and DisconnectAddIn
' subroutines in addition to the About event
' handler code.
' ************************************************
Option Explicit

' The environment instance.
Dim VBInstance As VBIDE.Application

' The Add-Ins submenu.
Dim ScrollerMenu As VBIDE.SubMenu

' The command lines.
Dim AboutLine As VBIDE.MenuLine
Dim ScrollerLine As VBIDE.MenuLine

' The event connection IDs. These represent the
' event handler to menu line connections.
Dim AboutID As Long
Dim ScrollerID As Long

' ************************************************
' Connect the add-in to the Visual basic
' environment. This happens when the user invokes
' the Add-in Manager to put the add-in in the
' Add-Ins menu.
' ************************************************
Sub ConnectAddIn(vb_instance As VBIDE.Application)
' Command event handler objects.
Dim scroller_handler As New ScrollerHandler

    ' Save the Visual Basic instance for later.
    Set VBInstance = vb_instance
    
    ' Add the submenu to the Add-Ins menu.
    Set ScrollerMenu = _
        VBInstance.AddInMenu.MenuItems.AddMenu _
            ("&Scroller")
        
    ' Add the submenu's commands.
    Set ScrollerLine = ScrollerMenu.MenuItems.Add("&Create Scrolling Area")
    Set AboutLine = ScrollerMenu.MenuItems.Add("About...")
    
    ' Connect event handler objects to the menu
    ' commands. Event handler objects have Public
    ' AfterClick subroutines.
    ScrollerID = ScrollerLine.ConnectEvents(scroller_handler)
    ' This object will handle the About AfterClick.
    AboutID = AboutLine.ConnectEvents(Me)
    
    ' Give the scroller event handler object
    ' the handle to the Visual Basic environment.
    Set scroller_handler.VBInstance = VBInstance
End Sub
' ************************************************
' Present the help dialog.
' ************************************************
Public Sub AfterClick()
    AboutDialog.Show vbModal
End Sub
' ************************************************
' Disconnect the add-in from the Visual basic
' environment. This happens when the user invokes
' the Add-in Manager to put the add-in in the
' Add-Ins menu.
' ************************************************
Sub DisconnectAddIn(mode As Integer)
    ' Disconnect the event handlers.
    ScrollerLine.DisconnectEvents ScrollerID
    AboutLine.DisconnectEvents AboutID
    
    ' Remove the submenu commands from the submenu.
    ScrollerMenu.MenuItems.Remove ScrollerLine
    ScrollerMenu.MenuItems.Remove AboutLine
    
    ' Remove the submenu.
    VBInstance.AddInMenu.MenuItems.Remove ScrollerMenu
End Sub

